/*
 *     DeleteClass.java  Jan 31, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.classes;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.query.*;
import java.util.*;
import javax.swing.JFrame;

public class DeleteClass extends ClassRefactoring {
    private DeleteClassTransformer transformer;

    public DeleteClass() {
        super();
    }

    public void setUpTest(JFrame f) {
        frame = f;
    }

    protected void preconditions() throws RefactoringException {
        if (QueryFile.usesTheClassExceptSelf(jfile, jclass)) {
            throw new RefactoringException("Not delete:" +
              " the class/interface " + jclass.getName() + " is used in the file " + getRelativeName(jfile.getName()));
        }

        ArrayList files = QueryProject.getAllJavaFilesUsingTheClassExceptSelf(jclass);
        if (files.size() != 0) {
            throw new RefactoringException("Not delete:" +
              " the class/interface " + jclass.getName() + " is used in the project");
        }
    }

    protected void transform() throws RefactoringException {
        transformer = new DeleteClassTransformer(jclass);
        transformer.changeSrc();
        unparse(jfile);
    }

    protected String getLog() {
        return jclass.getName() + " in " + getRelativeName(jfile.getName());
    }
}
