/*
 *     ExtractSubclass.java  Feb 1, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.classes;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.jrbx.refactor.dialog.*;
import org.jtool.platform.xml.wrapper.*;
import javax.swing.JFrame;
import java.util.*;

public class ExtractSubclass extends ExtractClass {
    private ExtractSubclassTransformer transformer;

    public ExtractSubclass() {
        super();
    }

    public void setUpTest(JFrame f, String newName) {
        frame = f;
        this.newName = newName;
    }

    protected void preconditions() throws RefactoringException {
        if (jclass.isFinal()) {
            throw new RefactoringException("Not extract:" +
              " the class/interface " + jclass.getName() + " is final");
        }

        if (newName == null) {
            newName = NewNameDialog.show(frame, "Extract Subclass");
        }

        super.preconditions();
    }

    protected void transform() throws RefactoringException {
        transformer = new ExtractSubclassTransformer(jclass, newName);
        transformer.changeSrc();
        unparse(jfile);
    }

    protected void additionalTransformation() throws RefactoringException {
        Iterator it = QueryClass.getAllChildren(jclass).iterator();
        while (it.hasNext()) {
            JavaClass jc = (JavaClass)it.next();

            transformer.changeRef(jc);
            unparse(jc.getJavaFile());
        }
    }

    protected String getLog() {
        return newName + " from " + jclass.getName() + " in " + getRelativeName(jfile.getName());
    }
}
