/*
 *     ExtractSuperclass.java  Jan 31, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.classes;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.dialog.*;
import javax.swing.JFrame;

public class ExtractSuperclass extends ExtractClass {
    private ExtractSuperclassTransformer transformer;

    public ExtractSuperclass() {
        super();
    }

    public void setUpTest(JFrame f, String newName) {
        frame = f;
        this.newName = newName;
    }

    protected void preconditions() throws RefactoringException {
        if (newName == null) {
            newName = NewNameDialog.show(frame, "Extract Superclass");
        }

        super.preconditions();
    }

    protected void transform() throws RefactoringException {
        transformer = new ExtractSuperclassTransformer(jclass, newName);
        transformer.changeSrc();
        unparse(jfile);
    }

    protected String getLog() {
        return newName + " from " + jclass.getName() + " in " + getRelativeName(jfile.getName());
    }
}
