/*
 *     DeleteField.java  Jan 31, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.fields;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import javax.swing.JFrame;

public class DeleteField extends FieldRefactoring {
    private DeleteFieldTransformer transformer;

    public DeleteField() {
        super();
    }

    public void setUpTest(JFrame f) {
        frame = f;
    }

    protected void preconditions() throws RefactoringException {        
        Iterator it = QueryFile.getAllJavaClasses(jfile).iterator();
        while (it.hasNext()) {
           JavaClass jc = (JavaClass)it.next();

           if (QueryClass.usesTheField(jc, jfield)) {
               throw new RefactoringException("Not delete:" +
                 " the field " + jfield.getName() + " is used in the class " + jc.getName());
           }
       }

       if (QueryProject.getAllJavaFilesUsingTheField(jfield).size() != 0) {
           throw new RefactoringException("Not delete:" +
             " the method " + jfield.getName() + " is used by the class in the project");
       }
    }

    protected void transform() throws RefactoringException {
        transformer = new DeleteFieldTransformer(jfield);
        transformer.run();
        unparse(jfile);
    }

    protected String getLog() {
        return jfield.getName() + " in " + jclass.getName();
    }
}
