/*
 *     FieldRefactoring.java  Feb 25, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.fields;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.platform.xml.JXConstants;
import java.util.*;

public class FieldRefactoring extends Refactoring {
    private static final String packagePath = "org.jtool.jrbx.refactor.fields";
    protected JavaField jfield;
    protected JavaClass jclass;

    protected FieldRefactoring() {
    }

    public static RefactoringCommand create(String command) {
        return create(command, packagePath);
    }

    public static boolean isEnabled(ArrayList elems, String sort) {
        return elems.size() == 1 && sort != null && sort.equals(JXConstants.FieldElem);
    }

    protected void setUp() {
        jfield = new JavaField(elem);
        jclass = jfield.getJavaClass();
        jfile = jfield.getJavaFile();
    }

    protected void preconditions() throws RefactoringException {
    }

    protected void transform() throws RefactoringException {
    }

    protected void additionalTransformation() throws RefactoringException {
    }

    protected String getLog() {
        return "Field Refactoring: " + jfield.getName();
    }

    protected MethodCode getSetter(JavaField jfield, String name) {
        MethodCode setter = new MethodCode(Modifier.VOID, name);
        setter.addModifier(Modifier.PUBLIC);
        setter.addParameter(jfield.getType(), jfield.getTypeFqn(), jfield.getName());
        return setter;
    }

    protected MethodCode getGetter(JavaField jfield, String name) {
        MethodCode getter = new MethodCode(jfield.getType(), name);
        getter.addModifier(Modifier.PUBLIC);
        return getter;
    }
}
