/*
 *     PullUpFieldVisitor.java  Feb 7, 2004
 *
 *     Katsuhisa Maruyama (maru@fse.cs.ritsumei.ac.jp)
 */

package org.jtool.jrbx.refactor.fields;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import org.w3c.dom.*;
import java.util.*;

public class PullUpFieldTransformer extends RefactoringTransformer {
    private JavaField jfield;

    private PullUpFieldTransformer() {
    }

    public PullUpFieldTransformer(JavaField jfield) {
        this.jfield = jfield;
    }

    public void changeSrc() {
        delete(jfield);
    }

    public void changeDst(JavaClass dclass) {
        Node node = insert(jfield, dclass);

        JavaField jf = new JavaField(node);
        if (jf.isPrivate() || jf.isDefault()) {
            changeAccessModifier(jf, "protected");
        }
    }

    public void changeRef(JavaFile rfile, String refName) {
        renameDotPrefix(rfile, jfield, refName);
    }
}
