/*
 *     RenameField.java  Feb 2, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.fields;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.jrbx.refactor.dialog.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import javax.swing.JFrame;

public class RenameField extends FieldRefactoring {
    private String newName = null;
    private RenameFieldTransformer transformer;

    public RenameField() {
        super();
    }

    public void setUpTest(JFrame f, String newName) {
        frame = f;
        this.newName = newName;
    }

    protected void preconditions() throws RefactoringException {
        if (newName == null) {
            newName = RenameDialog.show(frame, "Rename Field", jfield.getName());
        }
        if (newName == null) {
            throw new RefactoringException("");
        }

        if (QueryClass.hasTheField(jclass, newName)) {
            throw new RefactoringException("Not rename:" +
              " the field " + newName + " already exists in the class " + jclass.getName());
        }
    }

    protected void transform() throws RefactoringException {
        transformer = new RenameFieldTransformer(jfield, newName);
        transformer.changeSrc();
        unparse(jfile);
    }
    
    protected void additionalTransformation() throws RefactoringException {
        ArrayList files = QueryProject.getAllJavaFilesUsingTheField(jfield);
        Iterator it = files.iterator();
        while (it.hasNext()) {
            JavaFile jf = (JavaFile)it.next();

            transformer.changeRef(jf);
            unparse(jf);
        }
    }

    protected String getLog() {
        return jfield.getName() + " to " + newName;
    }
}
