/*
 *     DeleteMethod.java  Feb 5, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.methods;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import javax.swing.JFrame;

public class DeleteMethod extends MethodRefactoring {
    private DeleteMethodTransformer transformer;

    public DeleteMethod() {
        super();
    }

    public void setUpTest(JFrame f) {
        frame = f;
    }

    protected void preconditions() throws RefactoringException {
        Iterator it = QueryFile.getAllJavaClasses(jfile).iterator();
        while (it.hasNext()) {
            JavaClass jc = (JavaClass)it.next();

            if (QueryClass.callsTheMethodExceptSelf(jc, jmethod)) {
                throw new RefactoringException("Not delete:" +
                  " the method " + jmethod.getName() + " is called in the class " + jc.getName());
            }
        }

        if (QueryProject.getAllJavaFilesCallingTheMethodExceptSelf(jmethod).size() != 0) {
            throw new RefactoringException("Not delete:" +
              " the method " + jmethod.getName() + " is called by the class in the project");
        }
        
        if (QueryMethod.getJavaMethodsWithTheSameSignature(jmethod, jclass.getDescendants()).size() != 1) {
            throw new RefactoringException("Not move:" +
              " the method " + jmethod.getName() + " is overridden by descendant of the class " + jclass.getName());
        }
    }

    protected void transform() throws RefactoringException {
        transformer = new DeleteMethodTransformer(jmethod);
        transformer.changeSrc();
        unparse(jfile);
    }

    protected String getLog() {
        return jmethod.getName() + " in " + jclass.getName();
    }
}
