/*
 *     PullUpMethodTransformer.java  Feb 7, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.methods;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import org.w3c.dom.*;

public class PullUpMethodTransformer extends RefactoringTransformer {
    private JavaMethod jmethod;

    private PullUpMethodTransformer() {
    }

    public PullUpMethodTransformer(JavaMethod jmethod) {
        this.jmethod = jmethod;
    }

    public void changeSrc() {
        delete(jmethod);
    }

    public void changeDst(JavaClass dclass) {
        Node node = insert(jmethod, dclass);
        
        JavaMethod jm = new JavaMethod(node);
        if (jm.isPrivate() || jm.isDefault()) {
            changeAccessModifier(jm, "protected");
        }
    }

    public void changeRef(JavaFile rfile, String refName) {
        renameDotPrefix(rfile, jmethod, refName);
    }
}
