/*
 *     RenameMethodTransformer.java  Feb 2, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.methods;
import org.jtool.jrbx.refactor.util.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import org.w3c.dom.*;

public class RenameMethodTransformer extends RefactoringTransformer {
    private JavaMethod jmethod;
    private String newName;

    private RenameMethodTransformer() {
    }

    public RenameMethodTransformer(JavaMethod jmethod, String newName) {
        this.jmethod = jmethod;
        this.newName = newName;
    }

    public void changeSrc() {
        rename(newName, jmethod);
    }

    public void changeRef(JavaFile rfile) {
        Iterator it = QueryFile.getJavaCallsUsingTheMethod(rfile, jmethod).iterator();
        while (it.hasNext()) {
            JavaCall ja = (JavaCall)it.next();

            rename(newName, ja);
        }
    }
}
