/*
 *     QueryImport.java  Jan 31, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.query;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import org.w3c.dom.*;

public class QueryImport {

    public static boolean hasImported(JavaImport jimport, JavaClassList classes) {
        Iterator it = classes.iterator();
        while (it.hasNext()) {
            JavaClass jc = (JavaClass)it.next();

            if (hasImported(jimport, jc)) {
                return true;
            }
        }
        return false;
    }

    public static boolean hasImported(JavaImport jimport, ArrayList nodes) {
        Iterator it = nodes.iterator();
        while (it.hasNext()) {
            JavaImport ji = new JavaImport((Element)it.next());

            if (hasImported(jimport, ji.getName())) {
                return true;
            }
        }
        return false;
    }

    public static boolean hasImported(JavaImport jimport, JavaClass jclass) {
        return hasImported(jimport, jclass.getFqn());
    }

    public static boolean hasImported(JavaImport jimport, String name) {
        String qname = jimport.getName();
        int len = qname.indexOf("*");
        
        if (len == -1) {
            if (qname.equals(name)) {
                return true;
            }

        } else {
            qname = qname.substring(0, len - 1);
            int len2 = name.lastIndexOf(".");

            if (len2 != -1) {
                name = name.substring(0, len2);
                if (qname.equals(name)) {
                    return true;
                }
            }
        }
        return false;
    }
}
