/*
 *     StatementRefactoring.java  Feb 25, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.statements;
import org.jtool.jrbx.refactor.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.platform.xml.JXConstants;
import java.util.*;

public class StatementRefactoring extends Refactoring {
    private static final String packagePath = "org.jtool.jrbx.refactor.statements";
    protected JavaStatement jstatement;
    protected JavaClass jclass;
    protected JavaMethod jmethod;

    protected StatementRefactoring() {
    }

    public static RefactoringCommand create(String command) {
        return create(command, packagePath);
    }

    public static boolean isEnabled(ArrayList elems, String sort) {
        return elems.size() == 1 && sort != null &&
            (isEnabledForSwitch(elems, sort) ||
             isEnabledForIf(elems, sort) ||
             isEnabledForWhile(elems, sort));
    }

    public static boolean isEnabledForSwitch(ArrayList elems, String sort) {
        return elems.size() == 1 && sort != null && sort.equals(JXConstants.Switch);
    }

    public static boolean isEnabledForIf(ArrayList elems, String sort) {
        return elems.size() == 1 && sort != null && sort.equals(JXConstants.If);
    }

    public static boolean isEnabledForWhile(ArrayList elems, String sort) {
        return elems.size() == 1 && sort != null && sort.equals(JXConstants.While);
    }

    protected void setUp() {
        jstatement = new JavaStatement(elem);
        jclass = jstatement.getJavaClass();
        jmethod = jstatement.getJavaMethod();
        jfile = jstatement.getJavaFile();
    }

    protected void preconditions() throws RefactoringException {
    }

    protected void transform() throws RefactoringException {
    }

    protected void additionalTransformation() throws RefactoringException {
    }

    protected String getLog() {
        return "Statement Refactoring: " + jstatement.getSort();
    }
}
