/*
 *     RenameVariable.java  Feb 1, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.variables;
import org.jtool.jrbx.refactor.*;
import org.jtool.jrbx.refactor.query.*;
import org.jtool.jrbx.refactor.dialog.*;
import org.jtool.platform.xml.wrapper.*;
import java.util.*;
import javax.swing.JFrame;

public class RenameVariable extends VariableRefactoring {
    private String newName = null;
    private RenameVariableTransformer transformer;

    public RenameVariable() {
        super();
    }

    public void setUpTest(JFrame f, String newName) {
        frame = f;
        this.newName = newName;
    }

    protected void preconditions() throws RefactoringException {
        if (newName == null) {
            newName = RenameDialog.show(frame, "Rename Variable", jvar.getName());
        }
        if (newName == null) {
            throw new RefactoringException("");
        }

        if (QueryMethod.hasTheVariable(jmethod, newName)) {
            throw new RefactoringException("Not rename:" +
              " the variable " + newName + " already exists in method " + jmethod.getName());
        }

        if (QueryClass.hasTheField(jclass, newName)) {
            throw new RefactoringException("Not rename:" +
              " the field " + newName + " alreasy exists in class " + jclass.getName());
        }
    }

    protected void transform() throws RefactoringException {
        transformer = new RenameVariableTransformer(jvar, newName);
        transformer.changeSrc();
        unparse(jfile);
    }

    protected String getLog() {
        return "from " + jvar.getName() + " to " + newName;
    }
}
