/*
 *     VariableRefactoring.java  Feb 25, 2004
 *
 *     Katsuhisa Maruyama (maru@jtool.org)
 */

package org.jtool.jrbx.refactor.variables;
import org.jtool.jrbx.refactor.*;
import org.jtool.platform.xml.wrapper.*;
import org.jtool.platform.xml.JXConstants;
import org.w3c.dom.*;
import java.util.*;

public class VariableRefactoring extends Refactoring {
    private static final String packagePath = "org.jtool.jrbx.refactor.variables";
    protected JavaLocal jvar;
    protected JavaClass jclass;
    protected JavaMethod jmethod;

    protected VariableRefactoring() {
    }

    public static RefactoringCommand create(String command) {
        return create(command, packagePath);
    }

    public static boolean isEnabled(ArrayList elems, String sort) {
        return elems.size() == 1 && sort != null &&
            (sort.equals(JXConstants.LocalElem) || sort.equals(JXConstants.ParameterElem));
    }

    protected void setUp() {
        jvar = getJavaLocal(elem);
        jclass = jvar.getJavaClass();
        jmethod = jvar.getJavaMethod();
        jfile = jvar.getJavaFile();
    }

    private JavaLocal getJavaLocal(Element e) {
        if (e.getNodeName().equals(JXConstants.ParameterElem)) {
            return new JavaParameter(e);
        } else if (e.getNodeName().equals(JXConstants.LocalElem)) {
            return new JavaLocal(e);
        }
        return null;
    }
            
    protected void preconditions() throws RefactoringException {
    }

    protected void transform() throws RefactoringException {
    }

    protected void additionalTransformation() throws RefactoringException {
    }

    protected String getLog() {
        return "Variable Refactoring: " + jvar.getName();
    }
}
